--[[

****************************************************************************************
Alt-Tabber

File date: 2009-06-01T17:48:53Z 
Project version: v1.4-11-g36e161f

Author: Ackis

****************************************************************************************

]]

local MODNAME	= "AltTabber"

AltTabber		= LibStub("AceAddon-3.0"):NewAddon(MODNAME, "AceConsole-3.0", "AceEvent-3.0")

local addon		= LibStub("AceAddon-3.0"):GetAddon(MODNAME)

-- Localization
do
	-- enUS stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "enUS", true)

	if not L then return end

	L["BGSNDON"] = "Enabling sound in background so you can hear ready checks while alt-tabbed."


	-- deDE stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "deDE")

	if not L then return end

	

	-- frFR stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "frFR")

	if not L then return end

	

	-- zhCN stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "zhCN")

	if not L then return end

	

	-- zhTW stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "zhTW")

	if not L then return end

	

	-- koKR stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "koKR")

	if not L then return end

	

	-- esES stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "esES")

	if not L then return end

	

	-- esMX stuff
	local L = LibStub("AceLocale-3.0"):NewLocale(MODNAME, "esMX")

	if not L then return end

	

end

local L = LibStub("AceLocale-3.0"):GetLocale(MODNAME, false)

local GetCVar = GetCVar
local PlaySoundFile = PlaySoundFile

function addon:OnInitialize()

	if LibStub:GetLibrary("LibAboutPanel", true) then
		LibStub("LibAboutPanel").new(nil, MODNAME)
	else
		self:Print("Lib AboutPanel not loaded.")
	end

end

function addon:OnEnable()

	self:RegisterEvent("READY_CHECK")

	--@alpha@
	self:Print("Sound_EnableAllSound " .. GetCVar("Sound_EnableAllSound"))
	self:Print("Sound_EnableSFX " .. GetCVar("Sound_EnableSFX"))
	self:Print("Sound_EnableSoundWhenGameIsInBG " .. GetCVar("Sound_EnableSoundWhenGameIsInBG"))
	self:RegisterEvent("CVAR_UPDATED")
	self:RegisterEvent("CVAR_UPDATE")
	self:RegisterEvent("PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE")
	self:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
	--@end-alpha@

end

--@alpha@

function addon:PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE()
	self:Print("PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE")
end

function addon:UPDATE_BATTLEFIELD_STATUS()
	self:Print("UPDATE_BATTLEFIELD_STATUS")
end

function addon:CVAR_UPDATE()

	self:Print("CVAR_UPDATE")
	self:Print("Sound_EnableAllSound " .. GetCVar("Sound_EnableAllSound"))
	self:Print("Sound_EnableSFX " .. GetCVar("Sound_EnableSFX"))
	self:Print("Sound_EnableSoundWhenGameIsInBG " .. GetCVar("Sound_EnableSoundWhenGameIsInBG"))

end

function addon:CVAR_UPDATED()

	self:Print("CVAR_UPDATED")
	self:Print("Sound_EnableAllSound " .. GetCVar("Sound_EnableAllSound"))
	self:Print("Sound_EnableSFX " .. GetCVar("Sound_EnableSFX"))
	self:Print("Sound_EnableSoundWhenGameIsInBG " .. GetCVar("Sound_EnableSoundWhenGameIsInBG"))

end

--@end-alpha@

function addon:READY_CHECK()

	-- Abuses a bug? in that PlaySoundFile will still play
	-- If sound is off, we want to play the readycheck
	if (GetCVar("Sound_EnableSFX") == "0") then
		-- If background sound is on, we can't do anything
		if (GetCVar("Sound_EnableSoundWhenGameIsInBG") == "0") then
			self:Print(L["BGSNDON"])
			-- Change the option to be on
			SetCVar("Sound_EnableSoundWhenGameIsInBG", "1")
		else
			PlaySoundFile("Sound\\interface\\ReadyCheck.wav")
		end
	end
end
